##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName
# sampledir (sampledir)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config/include file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for Termin

%define name	ksm-termin
%define version	1.0.7
%define release	10.0.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	A simple termin calendar
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Office/Other
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	ksm-lib-sh >= 5.0.1-0.0.0,ksm-textproc >= 1.0.1-11.0.0
#Provides:	sampled
#Conflicts:	sampled-other,libsample == 0.0.0
#Obsoletes:	mysampled

%description
This package provides a termin calendar.
It contains the following programs:

 ksm-termin, update-ksm-termin

After installation/upgrading this package users should refresh 
their HOME/.ksm-terminrc with update-ksm-termin

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample
#%{_confdir}/sample.conf

#%attr(744,root,root)/%{_rcdir}/sampled

%attr(755,root,root)%{_bindir}/ksm-termin
%attr(755,root,root)%{_bindir}/update-ksm-termin

%{_datadir}/RELEASE
%{_datadir}/VERSION
%{_datadir}/calendar.templ
%{_datadir}/ksm-terminrc.templ
%{_datadir}/todo.templ

/usr/share/applications/KSM-Termin.desktop
/usr/share/applications/KSM-TShow.desktop

%{_icondir}/16x16/apps/termin.png
%{_icondir}/22x22/apps/termin.png
%{_icondir}/32x32/apps/termin.png
%{_icondir}/48x48/apps/termin.png
#%{_icondir}/64x64/apps/termin.png
#%{_icondir}/128x128/apps/termin.png

#/usr/share/pixmaps/termin.png

%docdir %{_man1dir}
%{_man1dir}/ksm-termin.1.gz
%{_man1dir}/update-ksm-termin.1.gz

#%docdir %{_man8dir}
#%{_man8dir}/sampled.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# disable sample and stop sampled
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop > /dev/null 2>&1

# backup config files
#test -e %{_confdir}/sample.conf && cp %{_confdir}/sample.conf %{_confdir}/sample.conf.rpmsave
#test -e %{_scnfdir}/sample && cp %{_scnfdir}/sample %{_scnfdir}/sample.rpmsave

# uninstall desktop files
xdg-desktop-menu uninstall \
	/usr/share/applications/KSM-TShow.desktop \
	/usr/share/applications/KSM-Termin.desktop

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# all vars from new conf
#cf=%{_confdir}/sample.conf
#cnfvars='MyVar1 MyVar2'

# set links
#ln -sf %{_rcdir}/sampled %{_bindir}/rcsampled

# install desktop files
xdg-desktop-menu install --novendor \
	/usr/share/applications/KSM-TShow.desktop \
	/usr/share/applications/KSM-Termin.desktop

# install/update all users rc files
#updcmd='' usr='' u=''
#updcmd="%{_bindir}/update-ksm-termin -q"
# for all usr below /home/ do:
#usr=$(/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1)
#for u in $usr; do
#	if [ -e /home/${u}/.ksm-terminrc ]; then	# if exist rc file
#		/bin/su $u -c "$updcmd"
#	fi
#done
#echo "Package ksm-termin: All users rc files have been updated"
#echo "Package ksm-termin: All existing users rc files have been updated"

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		c='' s='' t=''
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "ksm-termin: Error - cmd replcnfvar not found or not executable!" >&2
#			echo "ksm-termin: Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		cnt=0 i=0
#		# array var MainArr (contignous index from 0)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#				let ++i
#			done
#		fi
#
#		# array var MainArr (contignous index from 1)
#		cnt=${#MainArr[@]}			# max members of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any member in use?
#			while [ "$i" -lt $cnt ]; do
#				let ++i
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# disable sample and stop sampled
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop > /dev/null 2>&1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/sample.conf && cp %{_confdir}/sample.conf %{_confdir}/sample.conf.rpmsave
	#test -e %{_scnfdir}/sample && cp %{_scnfdir}/sample %{_scnfdir}/sample.rpmsave

	#%{_bindir}/togglesample -d -q > /dev/null 2>&1
	#%{_rcdir}/sampled stop -q > /dev/null 2>&1

	# remove links
	#test -e /usr/local/bin/rcsampled && rm -f /usr/local/bin/rcsampled

	# uninstall desktop files
	xdg-desktop-menu uninstall \
		/usr/share/applications/KSM-TShow.desktop \
		/usr/share/applications/KSM-Termin.desktop
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/sample

#else							# upgrade package
fi
exit 0

%changelog
* Tue Oct 10 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.7-10.0.0
- 'ksm-termin' has been revised/improved.

* Sat Apr 29 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.7-9.1.0
- 'update-ksm-termin' has been revised/improved.

* Fri Mar 24 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.7-9.0.0
- 'update-ksm-termin' has been revised/improved.

* Fri Mar 24 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.7-8.0.0
- The RPM-Scriptlets have been revised/improved.

* Thu Mar 23 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.7-7.0.0
- 'ksm-termin' has been revised/improved.
- Moved 'KSM-TShow.desktop' to
  /usr/share/applications

* Sat Feb 18 2023 Repomaster <repomaster@kaesmann-online.de> 1.0.7-6.0.0
- 'ksm-termin' has been revised/improved.

* Mon Dec 12 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-5.3.0
- 'ksm-termin' has been revised/improved
  (dialog functions).

* Tue Nov 29 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-5.2.0
- 'ksm-termin' has been revised/improved
  (dialog functions).

* Mon Nov 28 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-5.1.0
- 'ksm-termin' has been revised/improved
  (dialog functions).

* Mon Nov 14 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-5.0.0
- 'ksm-termin' has been revised/improved
  (better use of big terminals).

* Tue Jun 14 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-4.2.0
- 'ksm-termin' has been revised/improved
  (added option -T).

* Tue Apr 05 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-4.1.0
- The RPM-Scriptlets have been revised/improved.

* Tue Apr 05 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-4.0.0
- 'update-ksm-termin' has been revised/improved.

* Thu Mar 31 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-3.5.0
- 'ksm-termin' has been revised/improved.

* Fri Mar 25 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-3.4.0
- Following progs have been revised/improved:
  ksm-termin, update-ksm-termin

* Fri Mar 18 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-3.3.0
- 'ksm-termin' has been revised/improved.

* Tue Mar 15 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-3.2.0
- 'ksm-termin' has been revised/improved:
  (reworked 'About KSM-Termin').

* Mon Mar 14 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-3.1.0
- Following progs have been revised/improved:
  ksm-termin, update-ksm-termin

* Mon Mar 07 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-3.0.0
- Following progs have been revised/improved:
  ksm-termin, update-ksm-termin

* Fri Feb 18 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-2.0.0
- ksm-termin has been revised/improved
  (now it comes with textgrafic).

* Sat Feb 05 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-1.1.0
- ksm-termin has been revised/improved.

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.7-1.0.0
- Update to the libfuncstd-sh 4.0.0

* Thu Mar 02 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.7-0.2.0
- The script ksm-termin has been revised
  (protection against marking a not seen termin).

* Sun Jan 22 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.7-0.1.0
- All scripts have been revised
  (using function GetOpt).

* Thu Jan 12 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.7-0.0.0
- Following scripts and files have been renamed:
  FROM                TO
  termin              ksm-termin
  update-termin       update-ksm-termin
  ~/.terminrc         ~/.ksm-terminrc
- All scripts have been revised.

* Sat Nov 26 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.6-0.0.1
- The docu of termin has been revised.

* Fri Nov 25 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.6-0.0.0
- The script termin has been revised.
  Format of datafiles has been changed.

* Tue Nov 08 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.5-0.1.0
- The script termin has been revised.

* Tue Sep 27 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.5-0.0.1
- The docu of termin has been revised.

* Thu Mar 31 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.5-0.0.0
- The script termink has been renamed to termin.
  The config file name has also been renamed.

* Fri Jan 29 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.4-0.2.0
- The script termink has been revised
  (fixed error while mark weekly).

* Fri Dec 04 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.4-0.1.0
- The package has been revised
  (fixed deleting calendar if mark a single event).

* Mon Nov 02 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.4-0.0.0
- The package has been revised (added calendar names).

* Sat Oct 31 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.3-0.1.0
- The scripts termink and update-termin have
  been revised.

* Sat Oct 31 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.3-0.0.0
- The package has been revised (introducing
  multiple calendars).
- The script update-termink has been renamed
  to update-termin
- The docu of the package has been revised.

* Thu Oct 16 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.2-0.4.1
- The docu of the package has been revised.

* Wed Mar 19 2014 Juergen Kaesmann <juergen@kaesmann.us> 1.0.2-0.4.0
- The script termink has been revised (cmd -O).

* Mon Aug 26 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.2-0.3.0
- The script termink has been revised (output of cmd -t).

* Thu Aug 08 2013 Juergen Kaesmann <juergen@kaesman.de> 1.0.2-0.2.0
- The script termink has been revised (added cmd -O).

* Wed Apr 03 2013 Juergen Kaesmann <juergen@kaesman.de> 1.0.2-0.1.1
- The RPM scriptlets have been revised.

* Sun Sep 30 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.2-0.1.0
- The package has been revised.

* Tue Sep 18 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.2-0.0.0
- In script termink the cmd -r has changed to -m.
- Added a character ('W' for weekly) as Flag.
- The format of the ~/.terminkrc has changed.

* Mon Aug 06 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.4.0
- The icons has been moved to /usr/share/icons/hicolor/NxN/apps/

* Thu Apr 12 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.3.0
- The scripts termink and update-termink are revised.
- The icon set is extended with 2 new sizes.

* Tue Apr 03 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.2.0
- The release naming scheme has changed ('.ksm' is removed).

* Thu Oct 27 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.2.0.ksm
- This is an adaptation to ksm-lib-sh-1.0.5-3.0.0.ksm.

* Sat Mar 12 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0.ksm
- The script termink is revised (cmd -b). Now we manage 2 backup sets
  of the data files.

* Thu Jan 20 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.1.ksm
- The file .terminkrc is corrected.

* Wed Jan 19 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.0.ksm
- Following files are renamed:
  termin to termink
  update-termin to update-termink
  .terminrc to .terminkrc

* Tue Jan 04 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.2.0.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Thu Sep 09 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.2.0.ksm
- The package has been integrated into the menu structure of KDE/GNOME.

* Wed Jun 09 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.3.ksm
- The package is revised.

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.2.ksm
- Read version and dependency infos from external files.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.1.ksm
- The docu has changed.

* Sat Jan 23 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.0.ksm
- The script update-termin is corrected.

* Fri Jan 15 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.2.ksm
- The package name (Release) has changed.

* Thu Nov 19 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.ksm.0.1
- The RPM scriptlets are corrected.

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The package management has changed to RPM.
